import com.cycling74.max.*;

// BGcounter == count bangs and send out a bang through the counter outlet
// int in inlet sets the outlet to send the bang
// first outlet is currrent bang count; the bangs then start at next one (1)

public class BGcounter extends MaxObject {
	int curcount;
	int totouts;

	BGcounter(Atom args[]) {
		if (args.length != 1) {
			error("BGcounter needs the number of outlets");
			return;
		}
		totouts = args[0].getInt();
		curcount = 0;
		declareIO(1, totouts+1);
	}

	public void bang() {
			outlet(0, curcount);
			outletBang(curcount);
			if (++curcount > totouts) {
				error("BGcounter: exceeded total declared outputs");
				curcount = totouts;
			}
	}

	public void inlet(int i) {
		curcount = i;
		if (curcount >= totouts) {
			error("BGcounter: exceeded total declared outputs");
			curcount = totouts;
		}
		outlet(0, curcount);
	}
}
